#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif


#include <gnome.h>

#include "interface.h"
#include "support.h"
#include "display.h"
#include "preferences.h"
#include "serialize.h"
#include "xmms2.h"
#include "util.h"

GtkWidget *mainwindow;
int want_verbose = 0;
extern Preferences *prefs;

#ifdef HAVE_LASH
# include <lash/lash.h>
void lash_setup(void) {;} 
void lash_process(void) {;}
gboolean glashproc (gpointer data) {
  lash_process();
  return(TRUE);
}
lash_client_t *lash_client;
#endif

int
main (int argc, char *argv[])
{

  srand(time(NULL));

  gnome_program_init (PACKAGE, VERSION, LIBGNOMEUI_MODULE,
                      argc, argv,
                      GNOME_PARAM_APP_DATADIR, PACKAGE_DATA_DIR,
                      NULL);

#ifdef HAVE_LASH
  lash_args_t *lash_args = lash_extract_args(&argc, &argv);
#endif

  init_preferences();
  load_preferences();
  if(prefs->xmms) init_xmms_session(); 
  init_autosave();

#ifdef HAVE_LASH
  lash_client = lash_init (lash_args, PACKAGE_NAME, 0  | LASH_Config_Data_Set ,LASH_PROTOCOL (2,0));
  if (!lash_client) {
    fprintf(stderr, "could not initialise LASH!\n");
  } else { 
    lash_setup();
    if (want_verbose) printf("Connected to LASH.\n");
  }
  //lash_args_destroy(lash_args);
#endif

  mainwindow = create_mainwindow ();
  gtk_widget_show (mainwindow);
  update_gui();
  init_treeviews();

  if (prefs->restore)
	  load_default_db();
#ifdef HAVE_LASH
  g_timeout_add(250,glashproc,NULL);
#endif
  gtk_main ();

  return 0;
}

