#include <gnome.h>

void build_db (void);

typedef struct {
	char *filename;
	char *songname;
	int  Artist;
	int  Album;

	int  size;              /* size of file in bytes  */
	int  tracklen;          /* Length of track in ms  */

	int  track_nr;          /* track number           */
	int  tracks;            /* number of tracks       */
	int  bitrate;           /* bitrate                */
	int  year;              /* year                   */
} MP3File;

typedef struct {
	char *artist;
} Artist;

typedef struct {
	char *album;
	char *coverimage;
	char *playlist;
	int Artist;
	int tracks;
} Album;

int get_artist_id (char *artist);
int get_album_id (int Artist, char *album);
int get_song_id (MP3File *mf);
int get_song_by_filename (char *filename);

int count_songs_by_artist (int Artist);
int count_songs_by_album (int Artist, int Album);

void clear_db(void);

/******************************************/

typedef struct {
	char *filename;
	int length;
	int tot_time, last_time;
	int tot_realtime, last_realtime;
	int last_ending, last_rewind;
	time_t last_played_date;

	int startedcount; /* playback of song started */
	int playcount; /* song has been played (full length) till the end (-2 sec grace) */
	int rewindcount; /* song has been restarted during playback */
	int cheatcount; /* used skipped to the end */
	int zapcount; /* user skipped / zapped song */

	int rating; /* user rating */
	//char *last_follow_up;
	//char **follow_up_list;
}SongStatistics;

void sync_stats (gboolean background);
