#define _GNU_SOURCE

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include "preferences.h"
#include "support.h"
#include "mp3db.h"
#include "xmms2.h"
#include "display.h"
#include "serialize.h"

extern Preferences *prefs;
extern GtkWidget *mainwindow;

int asave_tag = 0;

void load_default_db (void) {
	gchar *cfg=get_home_cfg(".mp3browser.db");
	load_db(cfg);
	g_free(cfg);
	update_list_artist();
	status_default();
  }

gint autosave_func(gpointer unused) {
	if (prefs->auto_save_db)
	{
	  gchar *cfg=get_home_cfg(".mp3browser.db");
	  save_db(cfg);
	  g_free(cfg);
	}
	return TRUE;
}

void  init_autosave(void){
	if (!asave_tag)
		asave_tag = gtk_timeout_add(300*1000, autosave_func, NULL);
}

void update_gui (void) {
	GtkWidget *widget;
	int xc = xmms_is_connected();
	widget=lookup_widget(mainwindow,"labelxmms");
	gtk_widget_set_sensitive (widget, xc);
	widget=lookup_widget(mainwindow,"button_xmms");
	gtk_widget_set_sensitive (widget, xc);
	widget=lookup_widget(mainwindow,"toggle_xmms");
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(widget), xc);
	widget=lookup_widget(mainwindow,"button9");
	gtk_widget_set_sensitive (widget, xc);
	widget=lookup_widget(mainwindow,"toggle_rnd");
	gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(widget), prefs->add_random);
	gtk_widget_set_sensitive (widget, xc);
	widget=lookup_widget(mainwindow,"image136");
	if (prefs->add_random) {
		gtk_image_set_from_icon_name(GTK_IMAGE(widget),"stock_shuffle",GTK_ICON_SIZE_BUTTON);
	} else {
		gtk_image_set_from_icon_name(GTK_IMAGE(widget),"stock_record-number",GTK_ICON_SIZE_BUTTON);
	}
}



gchar hex2char(gchar first_digit, gchar second_digit) {
	gchar result = 0;
	
	if (first_digit >= '0' && first_digit <= '9')
		result = (first_digit - '0') * 16;
	else if (first_digit >= 'a' && first_digit <= 'f')
		result = (first_digit - 'a' + 10) * 16;
	if (second_digit >= '0' && second_digit <= '9')
		result += second_digit - '0';
	else if (second_digit >= 'a' && second_digit <= 'f')
		result += second_digit - 'a' + 10;
	return result;
}

gchar *decode_string(gchar *string) {
	int i, j;
	gchar *result = g_malloc((strlen(string) + 1) * sizeof(gchar));

	/* decode %XX escape sequences to their corresponding chars: */
	for (i = 0, j = 0; i < strlen(string); i++) {
		if (string[i] == '%') {
			result[j] = hex2char(string[i+1], string[i+2]);
			i+=2;
			j++; 
		} else {
			result[j] = string[i];
			j++;
		}
	}
	result[j] = '\0';
	return result;
}

gchar *get_valid_utf8_str_alloc(const gchar *str_to_validate) {
	gchar *result = g_malloc(strlen(str_to_validate) + 1);

	if (g_utf8_validate(str_to_validate, -1, NULL)) {
		g_strlcpy(result, str_to_validate, strlen(str_to_validate) + 1);
	} else {
		int i;

		for (i = 0; i < strlen(str_to_validate) + 1; i++) {
			if (str_to_validate[i] >= 0) /* negative chars are non-ASCII (>127) chars */
				result[i] = str_to_validate[i];
			else
				result[i] = '?';
		}
	}
	return result;
}
